using System;
namespace Vrednost_dodele
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] s = Console.ReadLine().Split(' ');
            int n = int.Parse(s[0]);
            int m = int.Parse(s[1]);
            s = Console.ReadLine().Split(' ');
            int c = int.Parse(Console.ReadLine());
            int[] b = new int[m];
            for(int i = 0; i < m; i++)
                b[i] = int.Parse(s[i]);
            int[] a = new int[n];
            for (int i = 0; i < n; i++) a[i] = i+1;
            for(int i = 0; i <= n - m;i++)
            {
                for (int j = 1; j <= m; j++)
                    a[i + b[j-1]-1] = a[i + j-1];
            }
            double x = 0;
            for (int i = 0; i < n; i++)
                x += Math.Pow(c, i+1) * a[i];
            x = x % 998244353;
            Console.WriteLine(x);
        }
    }
}